      PROGRAM TABLES
C
C**** *TABLES*
C
C
C     PURPOSE.
C     --------
C          CREATES BYNARY BUFR TABLES USED BY BUFR EXPANSION
C          OR BUFR ENCODING SOFTWARE
C
C**   INTERFACE.
C     ----------
C          NONE.
C
C
C     *METHOD.
C      -------
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C          NONE.
C
C
C
C
C     REFERENCE.
C     ----------
C
C          BINARY UNIVERSAL FORM FOR DATA REPRESENTATION, FM 94 BUFR.
C
C          J.K.GIBSON AND M.DRAGOSAVAC,1987: DECODING DATA 
C          REPRESENTATION FM 94 BUFR,TECHNICAL MEMORANDUM NO.
C
C          J.K.GIBSON,1986:EMOS 2 - STANDARDS FOR SOFTWARE DEVELOPMENT
C          AND MAINTANANCE ,TECHICAL MEMORANDUM NO.       ECMWF.
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC       *ECMWF*       JANUARY 1991.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      CHARACTER*80  YINPUT
      CHARACTER*11  YBTABLE
      CHARACTER*11  yfname
      CHARACTER*11  YCTABLE
      CHARACTER*11  YDTABLE
      
C          2.   SET UP BUFR TABLE FILE NAME.
C                ----------------------------
C
C
C             BUFR EDITION 2 NAMING CONVENTION
C
C             BXXXXXYYZZ , CXXXXXYYZZ , DXXXXXYYZZ
C
C             B      - BUFR TABLE 'B'
C             C      - BUFR TABLE 'C'
C             D      - BUFR TABLE 'D'
C             XXXXX  - ORIGINATING CENTRE
C             YY     - VERSION NUMBER OF MASTER TABLE
C                      USED( CURRENTLY 2 )
C             ZZ     - VERSION NUMBER OF LOCAL TABLE USED
C
C             BUFR EDITION 3 NAMING CONVENTION
C
C             BWWWXXXYYZZ , CWWWXXXYYZZ , DWWWXXXYYZZ
C
C             B      - BUFR TABLE 'B'
C             C      - BUFR TABLE 'C'
C             D      - BUFR TABLE 'D'
C             WWW    - ORIGINATING SUB-CENTRE
C             XXX    - ORIGINATING CENTRE
C             YY     - VERSION NUMBER OF MASTER TABLE
C                      USED( CURRENTLY 2 )
C             ZZ     - VERSION NUMBER OF LOCAL TABLE USED
C
C
C
C     ------------------------------------------------------------------
C*          1.   CREATE BINARY BUFR TABLES.
C                __________________________
 100  CONTINUE
C
      YBTABLE=' '
      YCTABLE=' '
      YDTABLE=' '
      YCENTRE=' '
      yfname=' '
C
      YINPUT=' '
      WRITE(*,'(a,$)') ' ORIGINATING SUB-CENTER (3 digits):'
      READ(*,'(I3)') ISUB
      WRITE(Ysub,'(I3.3)') ISUB
c
      YINPUT=' '
      WRITE(*,'(a,$)') ' ORIGINATING CENTER (3 digits):'
      READ(*,'(I3)') ICENTRE
      WRITE(YCENTRE,'(I3.3)') ICENTRE
C
      WRITE(*,'(A,$)')    ' CREATE BUFR TABLE B (Y/N)                 :'
      READ (*,'(A1)')   YINPUT(1:1)
      IF(YINPUT(1:1).EQ.'Y'.OR.YINPUT(1:1).EQ.'y') THEN
         WRITE(*,'(a,$)') ' VERSION NUMBER OF MASTER TABLE  (2 digits):'
         READ(*,'(I2)') IVERSION
         WRITE(YVER,'(I2.2)') IVERSION
         WRITE(*,'(a,$)') ' VERSION NUMBER OF LOCAL TABLE   (2 digits):'
         READ(*,'(I2)') ILOCAL
         WRITE(YLOCAL,'(I2.2)') ILOCAL
         YBTABLE='B'//YSUB(1:3)//YCENTRE(1:3)//YVER(1:2)//YLOCAL(1:2)
c	 fr=index(ybtable,' ')
	 yfname=ybtable
	 
C
      WRITE(*,'(1H ,A,A)') 'Input  Table : ',YBTABLE//'.TXT'
      WRITE(*,'(1H ,A,A)') 'Binary Table : ',YBTABLE
      END IF
C
c      YINPUT=' '
c      WRITE(*,'(A,$)')    ' CREATE BUFR TABLE C (Y/N)                 :'
c      READ (*,'(A1)')  YINPUT(1:1)
c      IF(YINPUT(1:1).EQ.'Y'.OR.YINPUT(1:1).EQ.'y') THEN
c         WRITE(*,'(a,$)') ' VERSION NUMBER OF MASTER TABLE (2 digits) :'
c         READ(*,'(I2)') IVERSION
c         WRITE(YVER,'(I2.2)') IVERSION
c         WRITE(*,'(a,$)') ' VERSION NUMBER OF LOCAL TABLE (2 digits)  :'
c         READ(*,'(I2)') ILOCAL
c         WRITE(YLOCAL,'(I2.2)') ILOCAL
c         YCTABLE='C'//YCENTRE(1:5)//YVER(1:2)//YLOCAL(1:2)
C
c      WRITE(*,'(1H ,A,A)') 'Input  Table : ',YCTABLE//'.TXT'
c      WRITE(*,'(1H ,A,A)') 'Binary Table : ',YCTABLE
c      END IF
C
      YINPUT=' '
      WRITE(*,'(A,$)')    ' CREATE BUFR TABLE D (Y/N)                 :'
      READ (*,'(A1)')   YINPUT(1:1)
      IF(YINPUT(1:1).EQ.'Y'.OR.YINPUT(1:1).EQ.'y') THEN
         WRITE(*,'(a,$)') ' VERSION NUMBER OF MASTER TABLE (2 digits) :'
         READ(*,'(I2)') IVERSION
         WRITE(YVER,'(I2.2)') IVERSION
         WRITE(*,'(a,$)') ' VERSION NUMBER OF LOCAL TABLE  (2 digits) :'
         READ(*,'(I2)') ILOCAL
         WRITE(YLOCAL,'(I2.2)') ILOCAL
	 YDTABLE='D'//YSUB(1:3)//YCENTRE(1:3)//YVER(1:2)//YLOCAL(1:2)
C
      WRITE(*,'(1H ,A,A)') 'Input  Table : ',YDTABLE//'.TXT'
      WRITE(*,'(1H ,A,A)') 'Binary Table : ',YDTABLE
      END IF
C
C*          2. TABLE B.
C              --------
 200  CONTINUE
C
      IERR=0
c      print*,Yfname
      IF(Yfname.NE.' ') CALL BTABLE(Yfname,IERR)
      IF(IERR.NE.0) THEN
         WRITE(*,'(A)') ' Warning --- Bufr Table B not created.'
         IERR=0
      END IF
C
C*          3. TABLE C.
C              --------
 300  CONTINUE
C
c      IERR=0
c      IF(YCTABLE.NE.' ') CALL CTABLE(YCTABLE,IERR)
c      IF(IERR.NE.0) THEN
c         WRITE(*,'(A)') ' Warning --- Bufr Table C not created.'
c         IERR=0
c      END IF
C
C*          4. TABLE D.
C              --------
 400  CONTINUE
C
      IERR=0
      IF(YDTABLE.NE.' ') CALL DTABLE(YDTABLE,IERR)
      IF(IERR.NE.0) THEN
         WRITE(*,'(A)') ' Warning --- Bufr Table D not created.'
         IERR=0
      END IF
C
      END
      SUBROUTINE BTABLE(YNAME,KERR)
C
C**** *BTABLE*
C
C
C     PURPOSE.
C     --------
C          CREATE BUFR TABLE B IN BINARY FORM.
C
C**   INTERFACE.
C     ----------
C          NONE.
C
C
C     *METHOD.
C      -------
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C          NONE.
C
C
C
C
C     REFERENCE.
C     ----------
C
C          BINARY UNIVERSAL FORM FOR DATA REPRESENTATION, FM 94 BUFR.
C
C          J.K.GIBSON AND M.DRAGOSAVAC,1987: DECODING DATA 
C          REPRESENTATION FM 94 BUFR,TECHNICAL MEMORANDUM NO.
C
C          J.K.GIBSON,1986:EMOS 2 - STANDARDS FOR SOFTWARE DEVELOPMENT
C          AND MAINTANANCE ,TECHICAL MEMORANDUM NO.       ECMWF.
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC       *ECMWF*       JANUARY 1991.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      PARAMETER(JTAB=1000)
c
      character YENTRY*95
      CHARACTER*(*) YNAME
      CHARACTER*15  YFNAME
c
      character CTABBEN(JTAB)*64,CTABBU(JTAB)*24
C
C             CTABBEN      -  table B, ELEMENT NAME           array
C             CTABBU       -  table B, unit                   array
C
      integer   NTABBTR(JTAB),NTABBS (JTAB),NTABBRF(JTAB),
     1          NTABBDW(JTAB),NTABP(64,255)
C
C             NTABBTR    - table B,  table reference              array
C             NTABBS     - table B,  scale                        array
C             NTABBRF    - table B,  reference value              array
C             NTABBDW    - table B,  data width                   array

c      DIMENSION NTABBTR(JP),NTABBS(JP),NTABBRF(JP),NTABBDW(JP)
c      DIMENSION NTABP(64,255)

	integer idesc,iscale,irefv,iwidth
	character ydesc*48
	character*13 yunit
	
      CHARACTER*256 YTAB 
      CHARACTER*11  YTABB
      CHARACTER*256 CROOT
      CHARACTER    CTEXT*64
      
      DATA CTABBEN/JTAB*' '/,CTABBU/JTAB*' '/
C
C     ------------------------------------------------------------------
C*          1.   INITIALIZE CONSTANTS AND VARIABLES.
C                -----------------------------------
 100  CONTINUE
C
      KERR=0
      j=0
      ICLASS0=0
C
      DO 101 I=1,64
      do 101 j=1,255
        NTABP(I,j)=0
 101  CONTINUE

C
C             NTABBTR    - table B,  table reference              array
C             NTABBS     - table B,  scale                        array
C             NTABBRF    - table B,  reference value              array
C             NTABBDW    - table B,  data width                   array

      DO 102 i=1,JTAB
      NTABBTR(I)=0
      NTABBS (I)=0
      NTABBRF(I)=0
      NTABBDW(I)=0
      CTABBEN(I)=' '
      CTABBU (I)=' '
 102  CONTINUE
C
      YFNAME=YNAME//'.TXT'
c      print*,YFNAME
c      OPEN(UNIT=21,FILE=YFNAME,
c     1            ERR=401,
c     2            IOSTAT=IOS,form='formatted',      
c     1            STATUS='OLD')
C     ------------------------------------------------------------------
C*          2.   READ IN TABLE B ELEMENT.
C                ------------------------
C
      J=0
 200  CONTINUE
C
      open(unit=21,file=YFNAME,
     1             form='formatted',
c     2             recl=86,
     3             ERR=401,
     4             IOSTAT=IOS,
     5             status='old')
     
      read(21,'(i7,a47,a13,i5,i12,i4)',    
     .    iostat=ios,err=405,end=300)
     .    idesc,ydesc,yunit,iscale,irefv,iwidth

      IF(idesc.EQ.0) THEN
         CTABBEN(J)(48:64)= ydesc
c         WRITE(*,1001) CTABBEN(J)
c 1001    FORMAT(1H ,9X,A80)
         GO TO 200
      END IF 
c         WRITE(*,1002) yentry
c 1002    FORMAT(I7, 46X, 13X, I5, I12,I4)       
C
      
      J=J+1
      IF(J.GT.JTAB) THEN
         PRINT*,' DIMENSION TOO SMALL J=',J
         CALL ABORT
      END IF 
C
C     ------------------------------------------------------------------
C*          2.1  SET ARRAYS FOR TABLE REFERENCE, ELEMENT NAME, UNITS,
C*               REFERENCE VALUE AND DATA WIDTH.
C
 210  CONTINUE
C
      NTABBTR(J)=idesc
      NTABBS (J)=iscale
      NTABBRF(J)=irefv
      NTABBDW(J)=iwidth
C
      CTABBEN(J)=ydesc
      CTABBU (J)=yunit
C
      ICLASS=NTABBTR(J)/1000
      iyyy = NTABBTR(J)-iclass*1000
      iclass = iclass + 1
      ntabp(iclass,iyyy) = j
C
      
      if (j.le.10) then
      	WRITE(*,1000) NTABBTR(J),CTABBEN(J),CTABBU(J),NTABBS(J),
     1              NTABBRF(J),NTABBDW(J),ntabp(iclass,iyyy)
 1000 FORMAT(1H ,1X,I6.6,1X,A80,1X,A20,I3,I12,I4,I4)
      endif
C
      GO TO 200
C
C     ------------------------------------------------------------------
C*          3.   WRITE WORKING TABLE B INTO FILE.
C                --------------------------------
 300  CONTINUE
C
      OPEN(UNIT=10,FILE=YNAME,ERR=403,
     1             FORM='UNFORMATTED',
     2             ACCESS='SEQUENTIAL',
     3             STATUS='unknown')
C
      PRINT*,' NUMBER OF TABLE B ENTRIES IS ',J
      PRINT*,' '
      
      WRITE(10,IOSTAT=IOS,ERR=404)  NTABBTR,CTABBEN,CTABBU,
     1                              NTABBS ,NTABBRF,NTABBDW,
     2                              NTABP
C
      CLOSE(10)
C     -----------------------------------------------------------------
 400  CONTINUE
C
C
c      WRITE(*,'(1h ,i7)') (NTABP(I),I=1,64)
C
      RETURN
C
404   CONTINUE
      KERR=1
      WRITE(*,4404) IOS
 4404 FORMAT(1H ,'+++ WRITE ERROR ON UNIT 10 +++ IOS=',I6)
      RETURN
C
403   CONTINUE
      KERR=1
      WRITE(*,4403) IOS
4403  FORMAT(1H ,'+++ OPEN ERROR ON UNIT 10 +++ IOS=',I6)
      RETURN
C
C
402   CONTINUE
      KERR=1
      WRITE(*,4402) IOS
 4402 FORMAT(1H ,'+++ WRITE ERROR ON UNIT 21 +++ IOS=',I6)
      RETURN
C
C
405   CONTINUE
      KERR=1
      WRITE(*,4405) IOS
 4405 FORMAT(1H ,'+++ READ ERROR ON UNIT 21 +++ IOS=',I6)
      RETURN
CC
 401  CONTINUE
C
      KERR=1
      WRITE(*,4401) IOS
 4401 FORMAT(1H ,'+++OPEN ERROR ON INPUT TABLE B TEXT FILE+++ IOS=',I6)
C     
      RETURN
      END
      SUBROUTINE DTABLE(YNAME,KERR)
C
C**** *DTABLE*
C
C
C     PURPOSE.
C     --------
C          THE MAIN PURPOSE OF THIS PROGRAMME IS TO CREATE WORKING
C          TABLE OF SEQUENCE DESCRIPTORS FOR *BUFR* DECODING.
C
C**   INTERFACE.
C     ----------
C          NONE.
C
C
C
C
C     *METHOD.
C      -------
C          NONE.
C
C
C
C     EXTERNALS.
C     ----------
C          NONE.
C
C
C
C
C     REFERENCE.
C     ----------
C
C          BINARY UNIVERSAL FORM FOR DATA REPRESENTATION, *FM 94 BUFR*.
C
C          J.K.GIBSON AND *M.DRAGOSAVAC,1987:* DECODING *DATA *REPRESENTATION
C                          *FM 94 BUFR*,*TECHNICAL *MEMORANDUM *NO.
C
C          J.K.GIBSON,1986:*EMOS 2 - *STANDARDS FOR SOFTWARE DEVELOPMENT
C                           AND MAINTANANCE *,*TECHICAL MEMORANDUM *NO.
C                           *ECMWF*.
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC       *ECMWF*       JANUARY 1991.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      PARAMETER(JP=2000,JL=50)
C
      CHARACTER*40 YENTRY
      CHARACTER*15 YFNAME
      CHARACTER*(*) YNAME
C
      DIMENSION NTABDTR(JP),NTABDL(JP),NTABDST(JP),NTABDSQ(JP*50),
     1          NLIST  (JL)
C
C     ------------------------------------------------------------------
C*          1.   SET INITIAL CONSTANTS.
C                ----------------------
 100  CONTINUE
C
      KERR=0
      J  =0
      IST=1
C
      DO 101 I=1,JP
      NTABDTR(I)=0
      NTABDL (I)=0
      NTABDST(I)=0
 101  CONTINUE
C
      DO 102 I=1,JP*50
      NTABDSQ(I)=0
 102  CONTINUE
C
      DO 103 I=1,JL
      NLIST(I)=0
 103  CONTINUE
C
      YFNAME=YNAME//'.TXT'
c      OPEN(UNIT=21,ERR=401,FILE=YFNAME,STATUS='OLD')
      open(unit=23,file=YFNAME,
     1             form='formatted',
     3             ERR=401,
     4             IOSTAT=IOS,
     5             status='old')
C
C     ------------------------------------------------------------------
C*          2.   READ IN TABLE D
C                ---------------
C
 200  CONTINUE
C
      READ(23,'(A)',ERR=402,iostat=ios,END=300) YENTRY
c      print*,yentry
      J=J+1
C
      IF(J.GT.JP) THEN
         PRINT*,' DIMENSION TOO SMALL J=',J
         CALL ABORT
      END IF 
C
C     ------------------------------------------------------------------
C*          2.1  SET ARRAYS FOR TABLE REFERENCE, DATA LENGTH,
C*               STARTING POINTER AND SEQUENCE DESCRIPTORS.
C
 210  CONTINUE
C
C
      READ(YENTRY,'(I6,1X,I2)') NTABDTR(J),NTABDL (J)
C
      IF(J.EQ.1) THEN
         IST=1
         NTABDST(J)=IST
      ELSE
         IST=IST + NTABDL(J-1)
         NTABDST(J)=IST
      END IF
C
      IF(NTABDL(J).GT.1) THEN
         READ(YENTRY,'(10X,I6)') NTABDSQ(IST)	 
         IIST=IST
C
         DO 220 JA=1,NTABDL(J)-1
         IIST=IIST+1
         READ(23,'(A)',END=300) YENTRY
         READ(YENTRY,'(10X,I6)') NTABDSQ(IIST)
 220     CONTINUE
C
      ELSE
         READ(YENTRY,'(10X,I6)') NTABDSQ(IST)
      END IF
C
C
      if (j .le. 10) then
      WRITE(*,1000) NTABDTR(J),NTABDL(J),NTABDST(J),
     1              (NTABDSQ(I),I=NTABDST(J),NTABDL(J)+NTABDST(J)-1)
 1000 FORMAT(1H ,I6,1X,I2,1X,I6,1X,I6/ (18X,I6))
      endif
C
      GO TO 200
C
C     ------------------------------------------------------------------
C*          3.   WRITE WORKING TABLE D INTO FILE 
C                --------------------------------
 300  CONTINUE
C
C
      OPEN(UNIT=22,FILE=YNAME,ERR=403,iostat=ios,
     1             FORM='UNFORMATTED',
     2             ACCESS='SEQUENTIAL',
     3             STATUS='unknown')
C
      WRITE(22,IOSTAT=IOS,ERR=404) NTABDTR,NTABDL,NTABDST,NTABDSQ
C
      WRITE(*,3000) J
 3000 FORMAT(1H ,' NUMBER OF TABLE D ENTRIES IS ', I4)
C
      RETURN
C     -----------------------------------------------------------------
 400  CONTINUE
C
 401  CONTINUE
C
      KERR=1
      WRITE(*,4401) IOS
 4401 FORMAT(1H ,'+++ OPEN ERROR ON INPUT TABLE D TAXT FILE +++IOS=',I6)
      RETURN
C
 402  CONTINUE
C
      KERR=1
      WRITE(*,4402) IOS
 4402 FORMAT(1H ,'+++ READ ERROR ON UNIT 21+++IOS=',I6)
      RETURN
C
 403  CONTINUE
C
      KERR=1
      WRITE(*,4403) IOS
 4403 FORMAT(1H ,'+++ OPEN ERROR ON UNIT 22 +++IOS=',I6)
      RETURN
C
404   CONTINUE
C   
      KERR=1
      WRITE(*,4404) IOS
 4404 FORMAT(1H ,'+++ WRITE ERROR ON UNIT 22 +++ IOS=',I6)
      RETURN
C
      END
      SUBROUTINE CTABLE(YNAME,KERR)
C
C**** *CTABLE*
C
C
C     PURPOSE.
C     --------
C          THE MAIN PURPOSE OF THIS PROGRAMME IS TO CREATE WORKING
C          CODE TABLES FOR *BUFR* DECODING.
C
C**   INTERFACE.
C     ----------
C          NONE.
C
C
C
C
C     *METHOD.
C      -------
C          NONE.
C
C
C
C     EXTERNALS.
C     ----------
C          NONE.
C
C
C
C
C     REFERENCE.
C     ----------
C
C          BINARY UNIVERSAL FORM FOR DATA REPRESENTATION, *FM 94 BUFR*.
C
C          J.K.GIBSON AND *M.DRAGOSAVAC,1987:* DECODING *DATA *REPRESENTATION
C                          *FM 94 BUFR*,*TECHNICAL *MEMORANDUM *NO. 134
C
C          J.K.GIBSON,1986:*EMOS 2 - *STANDARDS FOR SOFTWARE DEVELOPMENT
C                           AND MAINTANANCE *,*TECHICAL MEMORANDUM *NO.
C                           *ECMWF*.
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC       *ECMWF*       JANUARY 1991.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      PARAMETER(JP=120,JPN=15)
C
      CHARACTER CTEXT(JP*JPN*4)*64,YENTRY*80
      CHARACTER*14 YFNAME
      CHARACTER*(*) YNAME
C
      DIMENSION NREF(JP),NSTART(JP),NLEN(JP),NCODNUM(JP*JPN),
     1          NSTARTC(JP*JPN),NLENC(JP*JPN)
C
C     ------------------------------------------------------------------
C*          1.   SET INITIAL CONSTANTS AND POINTERS
C                ----------------------------------
 100  CONTINUE
C
      KERR=0
      J=0
      JPN4=JP*JPN*4
C
      DO 101 I=1,JPN4
      CTEXT(I)=' '
 101  CONTINUE
C
      DO 102 I=1,JP
      NREF(I)=0
      NSTART(I)=0
      NLEN(I)=0
 102  CONTINUE
C
      DO 103 I=1,JP*JPN
      NCODNUM(I)=0
      NSTARTC(I)=0
      NLENC  (I)=0
 103  CONTINUE
C
      YFNAME=YNAME//'.TXT'
      OPEN(UNIT=21,FILE=YFNAME,ERR=401,STATUS='OLD')
C
C     ------------------------------------------------------------------
C*          2.   READ IN CODE TABLE ENTRY
C                ------------------------
 200  CONTINUE
C
C
      READ(21,'(A)',ERR=402,END=300) YENTRY
C
      J = J+1
C
      IF(J.GT.JP) THEN
         PRINT*,' DIMENSION TOO SMALL J=',J
         CALL ABORT
      END IF 
C
C     ------------------------------------------------------------------
C*          2.1  SET ARRAYS FOR CODE TABLE TABLE REFERENCE, STARTING POINTERS
C                FOR LIST OF CODE NUMBERS, LENGTH , LIST OF CODE NUMBERS,
C                STARTING POINTERS AND LENGTH OF TEXT INFORMATION.
 210  CONTINUE
C
      READ(YENTRY,'(I6,1X,I4,1X,I4,1X,I2)') NREF(J),NLEN(J),NCODE,NLINE
C
      IF(J.EQ.1) THEN
         NSTART (J)  = 1
         NSTARTC(J)  = 1
         IPT = 1
         IIPT= 1
      ELSE
         NSTART(J)   = NSTART(J-1) + NLEN(J-1)
         IPT         = NSTART(J)
         IIPT        = IIPT + 1
         NSTARTC(IPT)= IIPT
      END IF
C
C
      NCODNUM(IPT)=NCODE
      NLENC ( IPT)=NLINE
C
      CTEXT (IIPT)=YENTRY(21:80)
C     -------------------------------------------------------------------
      IF(NLENC(IPT).GT.1) THEN
         DO 220 JA=1,NLENC(IPT)-1
         READ(21,'(A)',END=300) YENTRY
         IIPT=IIPT+1
         CTEXT(IIPT)=YENTRY(21:80)
 220     CONTINUE
      END IF
C
      IF(NLEN(J).GT.1) THEN
         DO 230 JA=1,NLEN(J)-1
         READ(21,'(A)',END=300) YENTRY
         READ(YENTRY,'(12X,I4,1X,I2)') NCODE,NLINE
         IPT   = IPT + 1
         IIPT  =IIPT + 1
         NCODNUM(IPT)= NCODE
         NSTARTC(IPT)=  IIPT
         NLENC  (IPT)=NLINE
         CTEXT(IIPT) = YENTRY(21:80)
         IF(NLENC(IPT).GT.1) THEN
            DO 240 JB=1,NLENC(IPT)-1
            READ(21,'(A)',END=300) YENTRY
            IIPT=IIPT+1
            CTEXT(IIPT)=YENTRY(21:80)
 240        CONTINUE
         END IF
 230     CONTINUE
      END IF
C
      GO TO 200
C
C     ------------------------------------------------------------------
C*          3.   WRITE WORKING CODE TABLE INTO FILE.
C                -----------------------------------
 300  CONTINUE
C
      OPEN(UNIT=22,FILE=YNAME,ERR=403,
     1             FORM='UNFORMATTED',
     3             STATUS='NEW')
c
      WRITE(22,IOSTAT=IOS,ERR=404) NREF,NSTART,NLEN,NCODNUM,
     1                             NSTARTC,NLENC,CTEXT
C
      CLOSE(21)
      CLOSE(22)
C     -----------------------------------------------------------------
C*          3.1  WRITE TABLES ON OUTPUT FILE
C                ---------------------------
 310  CONTINUE
C
      JEND=J
      DO 311 J=1,JEND
C
      IPT=NSTART(J)
      IIPT=NSTARTC(IPT)
c      WRITE(*,999) NREF(J),NLEN(J),NCODNUM(IPT),NLENC(IPT),CTEXT(IIPT)
C
      IF(NLENC(IPT).GT.1) THEN
         DO 312 JA=1,NLENC(IPT)-1
         IIPT = IIPT + 1
c         WRITE(*,998) CTEXT(IIPT)
 312     CONTINUE
      END IF
C
      IF(NLEN(J).GT.1) THEN
         DO 313 JB=1,NLEN(J)-1
         IPT = IPT + 1
         IIPT= NSTARTC(IPT)
c         WRITE(*,997) NCODNUM(IPT),NLENC(IPT),CTEXT(IIPT)
         IF(NLENC(IPT).GT.1) THEN
            DO 314 JC=1,NLENC(IPT)-1
            IIPT= IIPT + 1
c            WRITE(*,998) CTEXT(IIPT)
 314        CONTINUE
         END IF
 313     CONTINUE
      END IF
C
 311  CONTINUE

C
      RETURN
C     -----------------------------------------------------------------
 400  CONTINUE
C
 401  CONTINUE
C
      KERR=1
      WRITE(*,4401) IOS
 4401 FORMAT(1H ,'+++ OPEN ERROR ON UNIT 21 +++ IOS=',I6)
      RETURN
C
 402  CONTINUE
      KERR=1
      WRITE(*,4402) IOS
 4402 FORMAT(1H ,'+++ READ ERROR ON UNIT 21 +++ IOS=',I6)
      RETURN
C
 403  CONTINUE
C
      KERR=1
      WRITE(*,4403) IOS
 4403 FORMAT(1H ,'+++ OPEN ERROR ON UNIT 22 +++ IOS=',I6)
      RETURN
 404  CONTINUE
C
      KERR=1
      WRITE(*,4404) IOS
 4404 FORMAT(1H ,'+++ WRITE ERROR ON UNIT 22 +++ IOS=',I6)
      RETURN
C
c  997 FORMAT(1H ,14X,I4,1X,I2,1X,A)
c  998 FORMAT(1H ,22X,A)
c  999 FORMAT(1H ,2X,I6,1X,I4,1X,I4,1X,I2,1X,A)
C
      END
